ci/freedreno: Add a test run of a few driver options.
[mesa.git] / .gitlab-ci / deqp-runner.sh
index 044ff5981ad6eb3fe551c43ec89a11d039d210ed..d4de8f74baf9b0b8ffabb4409cd013ded2d0cc1b 100755 (executable)
@@ -1,34 +1,42 @@
-#!/bin/bash
+#!/bin/sh
 
 set -ex
 
-DEQP_OPTIONS=(--deqp-surface-width=256 --deqp-surface-height=256)
-DEQP_OPTIONS+=(--deqp-surface-type=pbuffer)
-DEQP_OPTIONS+=(--deqp-gl-config-name=rgba8888d24s8ms0)
-DEQP_OPTIONS+=(--deqp-visibility=hidden)
+DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-width=256 --deqp-surface-height=256"
+DEQP_OPTIONS="$DEQP_OPTIONS --deqp-surface-type=pbuffer"
+DEQP_OPTIONS="$DEQP_OPTIONS --deqp-gl-config-name=rgba8888d24s8ms0"
+DEQP_OPTIONS="$DEQP_OPTIONS --deqp-visibility=hidden"
 
 # It would be nice to be able to enable the watchdog, so that hangs in a test
 # don't need to wait the full hour for the run to time out.  However, some
 # shaders end up taking long enough to compile
 # (dEQP-GLES31.functional.ubo.random.all_per_block_buffers.20 for example)
 # that they'll sporadically trigger the watchdog.
-#DEQP_OPTIONS+=(--deqp-watchdog=enable)
+#DEQP_OPTIONS="$DEQP_OPTIONS --deqp-watchdog=enable"
 
 if [ -z "$DEQP_VER" ]; then
-   echo 'DEQP_VER must be set to something like "gles2" or "gles31" for the test run'
+   echo 'DEQP_VER must be set to something like "gles2", "gles31" or "vk" for the test run'
    exit 1
 fi
 
+if [ "$DEQP_VER" = "vk" ]; then
+   if [ -z "$VK_DRIVER" ]; then
+      echo 'VK_DRIVER must be to something like "radeon" or "intel" for the test run'
+      exit 1
+   fi
+fi
+
 if [ -z "$DEQP_SKIPS" ]; then
    echo 'DEQP_SKIPS must be set to something like "deqp-default-skips.txt"'
    exit 1
 fi
 
-ARTIFACTS=`pwd`/artifacts
+INSTALL=`pwd`/install
 
 # Set up the driver environment.
 export LD_LIBRARY_PATH=`pwd`/install/lib/
 export EGL_PLATFORM=surfaceless
+export VK_ICD_FILENAMES=`pwd`/install/share/vulkan/icd.d/"$VK_DRIVER"_icd.x86_64.json
 
 # the runner was failing to look for libkms in /usr/local/lib for some reason
 # I never figured out.
@@ -37,8 +45,14 @@ export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/usr/local/lib
 RESULTS=`pwd`/results
 mkdir -p $RESULTS
 
-# Generate test case list file
-cp /deqp/mustpass/$DEQP_VER-master.txt /tmp/case-list.txt
+# Generate test case list file.
+if [ "$DEQP_VER" = "vk" ]; then
+   cp /deqp/mustpass/vk-master.txt /tmp/case-list.txt
+   DEQP=/deqp/external/vulkancts/modules/vulkan/deqp-vk
+else
+   cp /deqp/mustpass/$DEQP_VER-master.txt /tmp/case-list.txt
+   DEQP=/deqp/modules/$DEQP_VER/deqp-$DEQP_VER
+fi
 
 # If the job is parallel, take the corresponding fraction of the caselist.
 # Note: N~M is a gnu sed extension to match every nth line (first line is #1).
@@ -46,30 +60,41 @@ if [ -n "$CI_NODE_INDEX" ]; then
    sed -ni $CI_NODE_INDEX~$CI_NODE_TOTAL"p" /tmp/case-list.txt
 fi
 
+if [ -n "$DEQP_CASELIST_FILTER" ]; then
+    sed -i "/$DEQP_CASELIST_FILTER/p" /tmp/case-list.txt
+fi
+
 if [ ! -s /tmp/case-list.txt ]; then
     echo "Caselist generation failed"
     exit 1
 fi
 
 if [ -n "$DEQP_EXPECTED_FAILS" ]; then
-    XFAIL="--xfail-list $ARTIFACTS/$DEQP_EXPECTED_FAILS"
+    XFAIL="--xfail-list $INSTALL/$DEQP_EXPECTED_FAILS"
 fi
 
 set +e
 
+if [ -n "$DEQP_PARALLEL" ]; then
+   JOB="--job $DEQP_PARALLEL"
+fi
+
 run_cts() {
-    caselist=$1
-    output=$2
+    deqp=$1
+    caselist=$2
+    output=$3
     deqp-runner \
-        --deqp /deqp/modules/$DEQP_VER/deqp-$DEQP_VER \
+        --deqp $deqp \
         --output $output \
         --caselist $caselist \
-        --exclude-list $ARTIFACTS/$DEQP_SKIPS \
+        --exclude-list $INSTALL/$DEQP_SKIPS \
+        --compact-display false \
         $XFAIL \
-        --job ${DEQP_PARALLEL:-1} \
+        $JOB \
        --allow-flakes true \
+       $DEQP_RUNNER_OPTIONS \
         -- \
-        "${DEQP_OPTIONS[@]}"
+        $DEQP_OPTIONS
 }
 
 report_flakes() {
@@ -114,10 +139,11 @@ extract_xml_result() {
                     if [ "$line" = "#endTestCaseResult" ]; then
                         echo $line >> $dst
                         echo "#endSession" >> $dst
-                        /deqp/executor/testlog-to-xml $dst "$RESULTS/$testcase.xml"
+                        /deqp/executor/testlog-to-xml $dst "$RESULTS/$testcase$DEQP_RUN_SUFFIX.xml"
                         # copy the stylesheets here so they only end up in artifacts
                         # if we have one or more result xml in artifacts
-                        cp /deqp/testlog.{css,xsl} "$RESULTS/"
+                        cp /deqp/testlog.css "$RESULTS/"
+                        cp /deqp/testlog.xsl "$RESULTS/"
                         return 0
                     fi
                     echo $line >> $dst
@@ -136,6 +162,53 @@ extract_xml_results() {
     done
 }
 
+# Generate junit results
+generate_junit() {
+    results=$1
+    echo "<?xml version=\"1.0\" encoding=\"utf-8\"?>"
+    echo "<testsuites>"
+    echo "<testsuite name=\"$DEQP_VER-$CI_NODE_INDEX\">"
+    while read line; do
+        testcase=${line%,*}
+        result=${line#*,}
+        # avoid counting Skip's in the # of tests:
+        if [ "$result" = "Skip" ]; then
+            continue;
+        fi
+        echo "<testcase name=\"$testcase\">"
+        if [ "$result" != "Pass" ]; then
+            echo "<failure type=\"$result\">"
+            echo "$result: See $CI_JOB_URL/artifacts/results/$testcase.xml"
+            echo "</failure>"
+        fi
+        echo "</testcase>"
+    done < $results
+    echo "</testsuite>"
+    echo "</testsuites>"
+}
+
+parse_renderer() {
+    RENDERER=`grep -A1 TestCaseResult.\*info.renderer $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
+    VERSION=`grep -A1 TestCaseResult.\*info.version $RESULTS/deqp-info.qpa | grep '<Text' | sed 's|.*<Text>||g' | sed 's|</Text>||g'`
+    echo "Renderer: $RENDERER"
+    echo "Version: $VERSION "
+
+    if ! echo $RENDERER | grep -q $DEQP_EXPECTED_RENDERER; then
+        echo "Expected GL_RENDERER $DEQP_EXPECTED_RENDERER"
+        exit 1
+    fi
+}
+
+check_renderer() {
+    echo "Capturing renderer info for driver sanity checks"
+    # If you're having trouble loading your driver, uncommenting this may help
+    # debug.
+    # export EGL_LOG_LEVEL=debug
+    VERSION=`echo $DEQP_VER | tr '[a-z]' '[A-Z]'`
+    $DEQP $DEQP_OPTIONS --deqp-case=dEQP-$VERSION.info.\* --deqp-log-filename=$RESULTS/deqp-info.qpa
+    parse_renderer
+}
+
 # wrapper to supress +x to avoid spamming the log
 quiet() {
     set +x
@@ -143,46 +216,72 @@ quiet() {
     set -x
 }
 
-run_cts /tmp/case-list.txt $RESULTS/cts-runner-results.txt
+if [ "$GALLIUM_DRIVER" = "virpipe" ]; then
+    # deqp is to use virpipe, and virgl_test_server llvmpipe
+    export GALLIUM_DRIVER="$GALLIUM_DRIVER"
+
+    GALLIUM_DRIVER=llvmpipe \
+    GALLIVM_PERF="nopt,no_filter_hacks" \
+    VTEST_USE_EGL_SURFACELESS=1 \
+    VTEST_USE_GLES=1 \
+    virgl_test_server >$RESULTS/vtest-log.txt 2>&1 &
+
+    sleep 1
+fi
+
+if [ $DEQP_VER != vk ]; then
+    quiet check_renderer
+fi
+
+RESULTSFILE=$RESULTS/cts-runner-results$DEQP_RUN_SUFFIX.txt
+UNEXPECTED_RESULTSFILE=$RESULTS/cts-runner-unexpected-results$DEQP_RUN_SUFFIX.txt
+FLAKESFILE=$RESULTS/cts-runner-flakes$DEQP_RUN_SUFFIX.txt
+
+run_cts $DEQP /tmp/case-list.txt $RESULTSFILE
 DEQP_EXITCODE=$?
 
+# junit is disabled, because it overloads gitlab.freedesktop.org to parse it.
+#quiet generate_junit $RESULTSFILE > $RESULTS/results.xml
+
 if [ $DEQP_EXITCODE -ne 0 ]; then
     # preserve caselist files in case of failures:
-    cp /tmp/cts_runner.*.txt $RESULTS/
-    echo "Some unexpected results found (see cts-runner-results.txt in artifacts for full results):"
-    cat $RESULTS/cts-runner-results.txt | \
-        grep -v ",Pass" | \
-        grep -v ",Skip" | \
-        grep -v ",ExpectedFail" > \
-        $RESULTS/cts-runner-unexpected-results.txt
-    head -n 50 $RESULTS/cts-runner-unexpected-results.txt
+    cp /tmp/deqp_runner.*.txt $RESULTS/
+    egrep -v ",Pass|,Skip|,ExpectedFail" $RESULTSFILE > $UNEXPECTED_RESULTSFILE.txt
 
-    # Save the logs for up to the first 50 unexpected results:
-    head -n 50 $RESULTS/cts-runner-unexpected-results.txt | quiet extract_xml_results /tmp/*.qpa
+    if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
+        echo "Some unexpected results found (see cts-runner-results.txt in artifacts for full results):"
+        head -n 50 $UNEXPECTED_RESULTSFILE.txt
+
+        # Save the logs for up to the first 50 unexpected results:
+        head -n 50 $UNEXPECTED_RESULTSFILE.txt | quiet extract_xml_results /tmp/*.qpa
+    else
+        echo "Unexpected results found:"
+        cat $UNEXPECTED_RESULTSFILE.txt
+    fi
 
-    count=`cat $RESULTS/cts-runner-unexpected-results.txt | wc -l`
+    count=`wc -l $UNEXPECTED_RESULTSFILE.txt`
 
     # Re-run fails to detect flakes.  But use a small threshold, if
     # something was fundamentally broken, we don't want to re-run
     # the entire caselist
 else
-    cat $RESULTS/cts-runner-results.txt | \
-        grep ",Flake" > \
-        $RESULTS/cts-runner-flakes.txt
+    grep ",Flake" $RESULTSFILE > $FLAKESFILE
 
-    count=`cat $RESULTS/cts-runner-flakes.txt | wc -l`
+    count=`wc -l $FLAKESFILE`
     if [ $count -gt 0 ]; then
         echo "Some flakes found (see cts-runner-flakes.txt in artifacts for full results):"
-        head -n 50 $RESULTS/cts-runner-flakes.txt
+        head -n 50 $FLAKESFILE
 
-        # Save the logs for up to the first 50 flakes:
-        head -n 50 $RESULTS/cts-runner-flakes.txt | quiet extract_xml_results /tmp/*.qpa
+        if [ -z "$DEQP_NO_SAVE_RESULTS" ]; then
+            # Save the logs for up to the first 50 flakes:
+            head -n 50 $FLAKESFILE | quiet extract_xml_results /tmp/*.qpa
+        fi
 
         # Report the flakes to IRC channel for monitoring (if configured):
-        quiet report_flakes $RESULTS/cts-runner-flakes.txt
+        quiet report_flakes $FLAKESFILE
     else
         # no flakes, so clean-up:
-        rm $RESULTS/cts-runner-flakes.txt
+        rm $FLAKESFILE
     fi
 fi